diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/spectrum/model/multi-model-spectrum-channel.cc ns-3.42/src/spectrum/model/multi-model-spectrum-channel.cc
--- ns-3.41/src/spectrum/model/multi-model-spectrum-channel.cc	2024-02-09 14:44:08.497794400 -0800
+++ ns-3.42/src/spectrum/model/multi-model-spectrum-channel.cc	2024-05-29 15:29:47.168073700 -0700
@@ -210,7 +210,6 @@
             {
                 NS_LOG_LOGIC("Creating converter between SpectrumModelUid "
                              << txSpectrumModelUid << " and " << rxSpectrumModelUid);
-
                 SpectrumConverter converter(txSpectrumModel, rxSpectrumModel);
                 auto ret2 = txInfoIterator->second.m_spectrumConverterMap.insert(
                     std::make_pair(rxSpectrumModelUid, converter));
@@ -237,21 +236,10 @@
                           // underlying DynamicCasts)
     m_txSigParamsTrace(txParamsTrace);
 
-    Ptr<MobilityModel> txMobility = txParams->txPhy->GetMobility();
-    SpectrumModelUid_t txSpectrumModelUid = txParams->psd->GetSpectrumModelUid();
+    auto txMobility = txParams->txPhy->GetMobility();
+    auto txSpectrumModelUid = txParams->psd->GetSpectrumModelUid();
     NS_LOG_LOGIC("txSpectrumModelUid " << txSpectrumModelUid);
 
-    //
-    auto txInfoIteratorerator =
-        FindAndEventuallyAddTxSpectrumModel(txParams->psd->GetSpectrumModel());
-    NS_ASSERT(txInfoIteratorerator != m_txSpectrumModelInfoMap.end());
-
-    NS_LOG_LOGIC("converter map for TX SpectrumModel with Uid " << txInfoIteratorerator->first);
-    NS_LOG_LOGIC(
-        "converter map size: " << txInfoIteratorerator->second.m_spectrumConverterMap.size());
-    NS_LOG_LOGIC("converter map first element: "
-                 << txInfoIteratorerator->second.m_spectrumConverterMap.begin()->first);
-
     for (auto rxInfoIterator = m_rxSpectrumModelInfoMap.begin();
          rxInfoIterator != m_rxSpectrumModelInfoMap.end();
          ++rxInfoIterator)
@@ -259,26 +247,6 @@
         SpectrumModelUid_t rxSpectrumModelUid = rxInfoIterator->second.m_rxSpectrumModel->GetUid();
         NS_LOG_LOGIC("rxSpectrumModelUids " << rxSpectrumModelUid);
 
-        Ptr<SpectrumValue> convertedTxPowerSpectrum;
-        if (txSpectrumModelUid == rxSpectrumModelUid)
-        {
-            NS_LOG_LOGIC("no spectrum conversion needed");
-            convertedTxPowerSpectrum = txParams->psd;
-        }
-        else
-        {
-            NS_LOG_LOGIC("converting txPowerSpectrum SpectrumModelUids "
-                         << txSpectrumModelUid << " --> " << rxSpectrumModelUid);
-            auto rxConverterIterator =
-                txInfoIteratorerator->second.m_spectrumConverterMap.find(rxSpectrumModelUid);
-            if (rxConverterIterator == txInfoIteratorerator->second.m_spectrumConverterMap.end())
-            {
-                // No converter means TX SpectrumModel is orthogonal to RX SpectrumModel
-                continue;
-            }
-            convertedTxPowerSpectrum = rxConverterIterator->second.Convert(txParams->psd);
-        }
-
         for (auto rxPhyIterator = rxInfoIterator->second.m_rxPhys.begin();
              rxPhyIterator != rxInfoIterator->second.m_rxPhys.end();
              ++rxPhyIterator)
@@ -289,8 +257,8 @@
 
             if ((*rxPhyIterator) != txParams->txPhy)
             {
-                Ptr<NetDevice> rxNetDevice = (*rxPhyIterator)->GetDevice();
-                Ptr<NetDevice> txNetDevice = txParams->txPhy->GetDevice();
+                auto rxNetDevice = (*rxPhyIterator)->GetDevice();
+                auto txNetDevice = txParams->txPhy->GetDevice();
 
                 if (rxNetDevice && txNetDevice)
                 {
@@ -310,18 +278,18 @@
                 }
 
                 NS_LOG_LOGIC("copying signal parameters " << txParams);
-                Ptr<SpectrumSignalParameters> rxParams = txParams->Copy();
-                rxParams->psd = Copy<SpectrumValue>(convertedTxPowerSpectrum);
-                Time delay = MicroSeconds(0);
+                auto rxParams = txParams->Copy();
+                rxParams->psd = Copy<SpectrumValue>(txParams->psd);
+                Time delay{0};
 
-                Ptr<MobilityModel> receiverMobility = (*rxPhyIterator)->GetMobility();
+                auto receiverMobility = (*rxPhyIterator)->GetMobility();
 
                 if (txMobility && receiverMobility)
                 {
-                    double txAntennaGain = 0;
-                    double rxAntennaGain = 0;
-                    double propagationGainDb = 0;
-                    double pathLossDb = 0;
+                    auto txAntennaGain{0.0};
+                    auto rxAntennaGain{0.0};
+                    auto propagationGainDb{0.0};
+                    auto pathLossDb{0.0};
                     if (rxParams->txAntenna)
                     {
                         Angles txAngles(receiverMobility->GetPosition(), txMobility->GetPosition());
@@ -329,8 +297,7 @@
                         NS_LOG_LOGIC("txAntennaGain = " << txAntennaGain << " dB");
                         pathLossDb -= txAntennaGain;
                     }
-                    Ptr<AntennaModel> rxAntenna =
-                        DynamicCast<AntennaModel>((*rxPhyIterator)->GetAntenna());
+                    auto rxAntenna = DynamicCast<AntennaModel>((*rxPhyIterator)->GetAntenna());
                     if (rxAntenna)
                     {
                         Angles rxAngles(txMobility->GetPosition(), receiverMobility->GetPosition());
@@ -360,7 +327,7 @@
                         // beyond range
                         continue;
                     }
-                    double pathGainLinear = std::pow(10.0, (-pathLossDb) / 10.0);
+                    auto pathGainLinear = std::pow(10.0, (-pathLossDb) / 10.0);
                     *(rxParams->psd) *= pathGainLinear;
 
                     if (m_propagationDelay)
@@ -372,7 +339,7 @@
                 if (rxNetDevice)
                 {
                     // the receiver has a NetDevice, so we expect that it is attached to a Node
-                    uint32_t dstNode = rxNetDevice->GetNode()->GetId();
+                    auto dstNode = rxNetDevice->GetNode()->GetId();
                     Simulator::ScheduleWithContext(dstNode,
                                                    delay,
                                                    &MultiModelSpectrumChannel::StartRx,
@@ -399,6 +366,40 @@
 MultiModelSpectrumChannel::StartRx(Ptr<SpectrumSignalParameters> params, Ptr<SpectrumPhy> receiver)
 {
     NS_LOG_FUNCTION(this);
+    const auto txSpectrumModelUid = params->psd->GetSpectrumModelUid();
+    const auto rxSpectrumModelUid = receiver->GetRxSpectrumModel()->GetUid();
+
+    auto txInfoIteratorerator =
+        FindAndEventuallyAddTxSpectrumModel(params->psd->GetSpectrumModel());
+    NS_ASSERT(txInfoIteratorerator != m_txSpectrumModelInfoMap.end());
+
+    NS_LOG_LOGIC("converter map for TX SpectrumModel with Uid " << txInfoIteratorerator->first);
+    NS_LOG_LOGIC(
+        "converter map size: " << txInfoIteratorerator->second.m_spectrumConverterMap.size());
+    NS_LOG_LOGIC("converter map first element: "
+                 << txInfoIteratorerator->second.m_spectrumConverterMap.begin()->first);
+
+    Ptr<SpectrumValue> convertedPsd;
+    if (txSpectrumModelUid == rxSpectrumModelUid)
+    {
+        NS_LOG_LOGIC("no spectrum conversion needed");
+        convertedPsd = params->psd;
+    }
+    else
+    {
+        NS_LOG_LOGIC("converting txPowerSpectrum SpectrumModelUids "
+                     << txSpectrumModelUid << " --> " << rxSpectrumModelUid);
+        auto rxConverterIterator =
+            txInfoIteratorerator->second.m_spectrumConverterMap.find(rxSpectrumModelUid);
+        if (rxConverterIterator == txInfoIteratorerator->second.m_spectrumConverterMap.end())
+        {
+            // No converter means TX SpectrumModel is orthogonal to RX SpectrumModel
+            return;
+        }
+        convertedPsd = rxConverterIterator->second.Convert(params->psd);
+        NS_LOG_LOGIC("convertedPsd " << convertedPsd->GetValuesN());
+    }
+    params->psd = convertedPsd;
     if (m_spectrumPropagationLoss)
     {
         params->psd =
@@ -408,10 +409,8 @@
     }
     else if (m_phasedArraySpectrumPropagationLoss)
     {
-        Ptr<const PhasedArrayModel> txPhasedArrayModel =
-            DynamicCast<PhasedArrayModel>(params->txPhy->GetAntenna());
-        Ptr<const PhasedArrayModel> rxPhasedArrayModel =
-            DynamicCast<PhasedArrayModel>(receiver->GetAntenna());
+        auto txPhasedArrayModel = DynamicCast<PhasedArrayModel>(params->txPhy->GetAntenna());
+        auto rxPhasedArrayModel = DynamicCast<PhasedArrayModel>(receiver->GetAntenna());
 
         NS_ASSERT_MSG(txPhasedArrayModel && rxPhasedArrayModel,
                       "PhasedArrayModel instances should be installed at both TX and RX "
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/spectrum/model/single-model-spectrum-channel.cc ns-3.42/src/spectrum/model/single-model-spectrum-channel.cc
--- ns-3.41/src/spectrum/model/single-model-spectrum-channel.cc	2024-02-09 14:44:08.497794400 -0800
+++ ns-3.42/src/spectrum/model/single-model-spectrum-channel.cc	2024-05-29 15:29:47.168073700 -0700
@@ -90,6 +90,11 @@
     {
         m_phyList.push_back(phy);
     }
+    else
+    {
+        // PHY has switched its channel, reset m_spectrumModel
+        m_spectrumModel = nullptr;
+    }
 }
 
 void
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/spectrum/model/spectrum-value.cc ns-3.42/src/spectrum/model/spectrum-value.cc
--- ns-3.41/src/spectrum/model/spectrum-value.cc	2024-02-09 14:44:08.497794400 -0800
+++ ns-3.42/src/spectrum/model/spectrum-value.cc	2024-05-29 15:29:47.168073700 -0700
@@ -394,12 +394,20 @@
 operator<<(std::ostream& os, const SpectrumValue& pvf)
 {
     auto it1 = pvf.ConstValuesBegin();
+    bool first = true;
     while (it1 != pvf.ConstValuesEnd())
     {
-        os << *it1 << " ";
+        if (!first)
+        {
+            os << " ";
+        }
+        else
+        {
+            first = false;
+        }
+        os << *it1;
         ++it1;
     }
-    os << std::endl;
     return os;
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/spectrum/model/three-gpp-channel-model.cc ns-3.42/src/spectrum/model/three-gpp-channel-model.cc
--- ns-3.41/src/spectrum/model/three-gpp-channel-model.cc	2024-02-09 14:44:08.497794400 -0800
+++ ns-3.42/src/spectrum/model/three-gpp-channel-model.cc	2024-05-29 15:29:47.172073600 -0700
@@ -22,6 +22,7 @@
 #include "three-gpp-channel-model.h"
 
 #include "ns3/double.h"
+#include "ns3/geocentric-constant-position-mobility-model.h"
 #include "ns3/integer.h"
 #include "ns3/log.h"
 #include "ns3/mobility-model.h"
@@ -42,6 +43,9 @@
 
 NS_OBJECT_ENSURE_REGISTERED(ThreeGppChannelModel);
 
+/// Conversion factor: degrees to radians
+static constexpr double DEG2RAD = M_PI / 180.0;
+
 /// The ray offset angles within a cluster, given for rms angle spread normalized to 1.
 /// (Table 7.5-3)
 static const double offSetAlpha[20] = {
